Global width = 800
Global height = 600
depth = 32

Global globaldiff$ = "Mailboy"

dataFile:TStream = OpenFile("Data/Game Settings.txt")
nothing$ = ReadLine(dataFile)
nothing$ = ReadLine(dataFile)
Global fullscreen = Int(ReadLine(dataFile))
nothing$ = ReadLine(datafile)
globaldiff = ReadLine(datafile)
CloseFile(dataFile)




depth = depth * fullscreen
AppTitle = "Personal Injury Lawyer"
Graphics width, height, depth

timeToQuit = 0
Global deltaT:Float
Global lasttime = MilliSecs()
Global debug = 1

SeedRnd(MilliSecs())

SetClsColor(155,155,155)

Include "Color and Shader.bmx"
Include "Animation.bmx"
Include "Graphics Related Types.bmx"
Include "Sound Related Types.bmx"

Global interfaceGraphics:graphicPile = graphicPile.create()
LoadImagesFromDir("Data/Interface", interfaceGraphics)

#mainmenu

SetBlend(ALPHABLEND)

FlushKeys()
While Not (KeyHit(KEY_ESCAPE) Or KeyHit(KEY_SPACE) Or KeyHit(KEY_RETURN) Or KeyHit(KEY_ENTER) Or MouseDown(1))
	DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
	DrawImage(interfaceGraphics.named("Super Title"), width/2, 300)
	Flip
	Cls
Wend

FlushKeys()
While Not (KeyHit(KEY_ESCAPE) Or KeyHit(KEY_SPACE) Or KeyHit(KEY_RETURN) Or KeyHit(KEY_ENTER) Or MouseHit(1))
	DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
	DrawImage(interfaceGraphics.named("Explain"), 395, 240)
	Flip
	Cls
Wend

doMenu()

Function doMenu()
	
	menuAudioContext:audioContext = AudioContext.create(2)
	siren:TSound = LoadSound("Data/Sounds/Siren3.ogg")
	SetChannelVolume(menuAudioContext.channels[1], 0)
	menuAudioContext.PlaySnd(siren, 1, 1)
	Global titleAng# = 0, titleOffset# = 10, titleAngSpeed# = 3		
	
	screenmode$ = "Main Menu"
	
	nothing = MouseHit(1); nothing = KeyHit(KEY_ESCAPE)
	While 1 = 1
	
		deltaT = (Float(MilliSecs()-lasttime))/1000.0; lasttime = MilliSecs()
		
		Global fullscreenchanged
		menuAudioContext.update()
	
		If screenmode = "Main Menu" Then
		
			titleAng = titleAng - titleAngSpeed * deltaT
			DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
			SetBlend(ALPHABLEND)
			DrawImage(interfaceGraphics.named("Title"), width/2 + Cos(titleAng)*titleOffset, ImageHeight(interfaceGraphics.named("Title")) * .6 + Sin(titleAng)*titleOffset)
			DrawImage(interfaceGraphics.named("Start Game"), width/2 + Cos(titleAng*4)*titleOffset, 200 + Sin(titleAng*4)*titleOffset)
			
			DrawImage(interfaceGraphics.named("Settings"), width/2 + Cos(-titleAng*3)*titleOffset, 400 + Sin(-titleAng*3)*titleOffset)
			
			DrawImage(interfaceGraphics.named("As Seen On TV"), width - 85+5*+ Cos(titleAng*10), height-68+5*+ Sin(titleAng*10))
			
			
			If  mouseOverRect(width/2 + Cos(titleAng*4)*titleOffset, 200 + Sin(titleAng*4)*titleOffset, ImageWidth(interfaceGraphics.named("Start Game")),  ImageHeight(interfaceGraphics.named("Start Game"))) Then
				SetChannelVolume(menuAudioContext.channels[1], .1)
				If MouseDown(1) Then
					PlayNewGame()
					FlushMem()
				End If
			Else
				SetChannelVolume(menuAudioContext.channels[1], 0)
			End If
			
			If  MouseHit(1) And mouseOverRect(width/2 + Cos(-titleAng*3)*titleOffset, 400 + Sin(-titleAng*3)*titleOffset, ImageWidth(interfaceGraphics.named("Settings")),  ImageHeight(interfaceGraphics.named("Settings"))) Then
				screenmode = "Settings"
				fullscreenchanged = fullscreen
			End If
			
		End If
		
		If screenmode = "Settings" Then
			titleAng = titleAng - titleAngSpeed * deltaT
			DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
			SetBlend(ALPHABLEND)
			DrawImage(interfaceGraphics.named("Settings"), width/2 + Cos(titleAng)*titleOffset, ImageHeight(interfaceGraphics.named("Settings")) * .6 + Sin(titleAng)*titleOffset)
			SetAlpha(Float(Fullscreen) * .6 + .4)
			DrawImage(interfaceGraphics.named("Full Screen"), width/2 + Cos(titleAng*4)*titleOffset, 200 + Sin(titleAng*4)*titleOffset)
			SetAlpha(1)
			
			DrawImage(interfaceGraphics.named("Back"), width/2 + Cos(titleAng*2)*titleOffset, 500 + Sin(titleAng*2)*titleOffset)
			
			DrawImage(interfaceGraphics.named("As Seen On TV"), width - 85+5*+ Cos(titleAng*10), height-68+5*+ Sin(titleAng*10))'
			
			DrawImage(interfaceGraphics.named(globalDiff), width/2 + Cos(-titleAng*3)*titleOffset, 320 + Sin(-titleAng*3)*titleOffset)
			
			defHit = MouseHit(1)
			If  defHit And mouseOverRect(width/2 + Cos(titleAng*4)*titleOffset, 200 + Sin(titleAng*4)*titleOffset, ImageWidth(interfaceGraphics.named("Start Game")),  ImageHeight(interfaceGraphics.named("Start Game"))) Then
				If fullscreen = 1 Then
					fullscreen = 0
				Else
					fullscreen = 1
				End If
				defHit = 0
			End If
			
			If  defHit And mouseOverRect(width/2 + Cos(-titleAng*3)*titleOffset, 320 + Sin(-titleAng*3)*titleOffset, ImageWidth(interfaceGraphics.named(globaldiff)),  ImageHeight(interfaceGraphics.named(globaldiff))) Then
				If globaldiff = "Senior Partner" Then
					globaldiff = "Mailboy2"
				End If
				If globaldiff = "Partner" Then
					globaldiff = "Senior Partner"
				End If
				If globaldiff = "Associate" Then
					globaldiff = "Partner"
				End If
				If globaldiff = "Mailboy" Then
					globaldiff = "Associate"
				End If
				If globaldiff = "Mailboy2" Then
					globaldiff = "Mailboy"
				End If
				defHit = 0
			End If
			
			If  defHit And mouseOverRect(width/2 + Cos(titleAng*2)*titleOffset, 500 + Sin(titleAng*2)*titleOffset, ImageWidth(interfaceGraphics.named("Back")),  ImageHeight(interfaceGraphics.named("Back"))) Then
				
				dataFile:TStream = OpenFile("Data/Game Settings.txt")
				WriteLine(Datafile, "User Settings:")
				WriteLine(Datafile, "Fullscreen (1 = yes, 0 = an 800x600 pixel window)")
				WriteLine(Datafile, String(fullscreen))
				WriteLine(Datafile, "Difficulty setting:")
				WriteLine(Datafile, globaldiff)
				CloseFile(dataFile)
				
				screenmode = "Main Menu"
				Print fullscreenchanged + " " + fullscreen
				If fullscreenchanged <> fullscreen Then
					EndGraphics()
					Graphics(width, height, 32 * fullscreen)
				End If
				
				defHit = 0
			End If
			
		End If
		
			wantsToExit()
		Flip
		Cls
	Wend

End Function

Function AddHighScore(score, diff$)
	nameSoFar$ = ""
	textscale = 5
	FlushKeys()
	While Not (KeyHit(KEY_ENTER) Or KeyHit(KEY_RETURN) Or KeyHit(KEY_ESCAPE))
		SetColor(155,155,155)
		DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
		SetColor(255,255,255)
		DrawImage(interfaceGraphics.named("Enter Name"), width/2, 100)
		SetScale(textscale, textscale)
		DrawText(nameSoFar$, width/2 - (TextWidth(namesofar) * textscale)*.5, height/2 - (TextHeight(namesofar) * textscale)*.5)
		SetScale(1, 1)
		key = GetChar()
		If key <> Null Then
			If key = 8 Or key = 46 Then
				If nameSoFar.length > 0 Then
					nameSoFar = nameSoFar[0..nameSoFar.length-1]
				End If
				Else
				If key = 13 Then
					Exit
				Else
					If key >31 And key <127 nameSoFar:+Chr(key)
				End If
			End If
		End If
		Flip
		Cls
	Wend
	Print "NAME SO FAR " + namesofar
	SaveScore(score, diff, nameSoFar)
	ShowScores()
End Function

Function SaveScore(score, diff$, pname$)
	data:TStream = OpenFile("Data/High Scores.txt")
	
	Local scoreNums:Int[] = New Int[scorecount]
	Local scoreNames:String[] = New String[scorecount]
	Local scoreDifficulty:String[] = New String[scorecount]
	
	While Not(Eof(data))
		scoreNums = scoreNums[0.. scoreNums.length+1]
		scoreNums[scoreNums.length - 1] = Int(ReadLine(data))
		scoreDifficulty = scoreDifficulty[0.. scoreDifficulty.length+1]
		scoreDifficulty[scoreDifficulty.length - 1] = ReadLine(data)
		scoreNames = scoreNames[0.. scoreNames.length+1]
		scoreNames[scoreNames.length - 1] = ReadLine(data)
	Wend
	scorecount = scoreNums.length
	
	rem
	For i = 0 To scorecount - 1
		If score >= scoreNums[i] Then
			For r = scorecount To i + 1
				scorenums[r] = scorenums[r-1]
				ScoreDifficulty[r] = ScoreDifficulty[r-1]
				scoreNames[r] = scoreNames[r-1]
			Next
			scoreNums[i] = score
			ScoreDifficulty[i] = diff
			scoreNames[i] = pname
			Exit
		End If
	Next
	end rem
	
	CloseFile(data)
	
	'DeleteFile("High Scores.txt")
	'CreateFile("High Scores.txt")
	data:TStream = OpenFile("Data/High Scores.txt")
	playerdatain = 0
	r = 0
	pickupFrom = scorecount
	
	If scorecount > 0 Then
	Print "scorecount > 0"
	For i = 0 To scorecount - 1
		Print "loop 1 iteration " + (i + 1)
		If scoreNums[i] <= score
			Print "scoreNums[i] <= score, writing player score"
			WriteLine(data, score)
			WriteLine(data, diff)
			WriteLine(data, pname)
			pickupFrom = i
			playerdatain = 1
			Exit
		Else
			Print "scoreNums[i] >= score, writing an old score"
			WriteLine(data, scoreNums[i])
			WriteLine(data, scoreDifficulty[i])
			WriteLine(data, scoreNames[i])
		End If
	Next
	
	For r = pickupFrom To scorecount - 1
		Print "loop 2 iteration " + (r + 1)
		WriteLine(data, scoreNums[r])
		WriteLine(data, scoreDifficulty[r])
		WriteLine(data, scoreNames[r])
	Next
	End If
	
	If playerdatain = 0 Then
		Print "backup writein"
		WriteLine(data, score)
		WriteLine(data, diff)
		WriteLine(data, pname)
		playerdatain = 1
	End If
	
	rem
	If scorecount <> 0 Then
		While r < scorecount
			If score > scoreNums[r] Then
				WriteLine(data, scoreNums[r])
				WriteLine(data, scoreDifficulty[r])
				WriteLine(data, scoreNames[r])
				r = r + 1
			Else
				If playerdatain = 0 Then
					Print "writing ahead (cause its higher)"
					WriteLine(data, score)
					WriteLine(data, diff)
					WriteLine(data, pname)
					playerdatain = 1
				Else
					r = r + 1
				End If
			End If
		Wend
	Else
		Print "writing the lot!"
		WriteLine(data, score)
		WriteLine(data, diff)
		WriteLine(data, pname)
		playerdatain = 1
	End If
	
	If playerdatain = 0 Then
		Print "backup writein"
		WriteLine(data, score)
		WriteLine(data, diff)
		WriteLine(data, pname)
		playerdatain = 1
	End If
	end rem


	CloseFile(data)
End Function

Function ShowScores()
	data:TStream = OpenFile("Data/High Scores.txt")
	
	Local scoreNums:Int[] = New Int[scorecount]
	Local scoreNames:String[] = New String[scorecount]
	Local scoreDifficulty:String[] = New String[scorecount]
	
	While Not(Eof(data))
		scoreNums = scoreNums[0.. scoreNums.length+1]
		scoreNums[scoreNums.length - 1] = Int(ReadLine(data))
		scoreDifficulty = scoreDifficulty[0.. scoreDifficulty.length+1]
		scoreDifficulty[scoreDifficulty.length - 1] = ReadLine(data)
		scoreNames = scoreNames[0.. scoreNames.length+1]
		scoreNames[scoreNames.length - 1] = ReadLine(data)
		Print "Read 1 layer of data!"
	Wend
	scorecount = scoreNums.length
	rem
	For i = 0 To scorecount - 1
		scoreNums[i] = Int(ReadLine(data))
		ScoreDifficulty[i] = ReadLine(data)
		scoreNames[i] = ReadLine(data)
	Next
	end rem
	CloseFile(data)
	
	
	FlushKeys()
	While Not (KeyHit(KEY_ENTER) Or KeyHit(KEY_RETURN) Or KeyHit(KEY_ESCAPE) Or MouseHit(1))
		SetColor(255,255,255)
		DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
		DrawImage(interfaceGraphics.named("High Scores"), width/2, 50)
		SetAlpha(.6)
		SetColor(0,0,0)
		DrawRect(30, 100, width - 60, height-200)
		SetAlpha(1)
		SetColor(255,255,255)
		SetScale(2, 2)
		
		If scorecount > 10 Then
			scorecount = 10
		End If
		
		For i = 0 To scorecount -1
			DrawText("$" + scorenums[i] + "00", 40, 110 + 30 * i)
			DrawText(scoreDifficulty[i], 170, 110 + 30 * i)
			DrawText(scoreNames[i], 420, 110 + 30 * i)
		Next
		
		SetScale(1,1)
		Flip
		Cls
	Wend
	
	
End Function

Function mouseOverRect:Int(x, y, rw, rh)
	rw = rw * .5; rh = rh * .5
	If MouseX() > x - rw And MouseX() < x + rw And MouseY() > y - rh And MouseY() < y + rh Then
		Return 1
	Else
		Return 0
	End If
End Function

Function wantsToExit:Int()
	If KeyHit(KEY_ESCAPE) Then
		
		timetoquit=0
		Global titleAng = 0
		
			deltaT = (Float(MilliSecs()-lasttime))/1000.0; lasttime = MilliSecs()
			titleAng = titleAng + deltaT
			titleOffset = 20
			'DrawImage(interfaceGraphics.named("Promo1"), width/2, height/2)
			SetBlend(alphablend)
			SetColor(255,255,255)
			For i = 0 To width/2
				SetAlpha(i / Float(width/2))
				DrawRect(i, i, width-(2*i), height - (2*i))
			Next
			SetAlpha(1)
			
			DrawImage(interfaceGraphics.named("Back To Game"), 300, 160)
			
			DrawImage(interfaceGraphics.named("Main Menu"), 380, 240)
			
			DrawImage(interfaceGraphics.named("Quit"), 460, 320)
			
			Flip
			Cls	
			SetBlend(alphablend)
			SetAlpha(1)
			SetColor(255,255,255)
			
		While Not timetoquit
			If KeyHit(key_escape) Or (MouseDown(1) And mouseOverRect(300, 160, ImageWidth(interfaceGraphics.named("Back To Game")), ImageHeight(interfaceGraphics.named("Back To Game")))) Then
				Return 0
			End If
			
			If  MouseDown(1) And mouseOverRect(380, 240, ImageWidth(interfaceGraphics.named("Main Menu")), ImageHeight(interfaceGraphics.named("Main Menu"))) Then
				Return 1
			End If
			
			If  MouseDown(1) And mouseOverRect(460, 320, ImageWidth(interfaceGraphics.named("Quit")), ImageHeight(interfaceGraphics.named("Quit"))) Then
				End
			End If
			lasttime = MilliSecs()
		Wend
	End If
End Function


Function PlayNewGame:Int()
	Newgame:game = game.create(globaldiff)
	While Not timeToQuit
		deltaT = (Float(MilliSecs()-lasttime))/1000.0; lasttime = MilliSecs()
		
		Newgame.update()
		If newgame.over = 1 Then
			AddHighScore(newgame.L.cashgained, newgame.gamediff)
			Return
		End If
		Newgame.draw(0,0)
		
		quit = wantsToExit()
		If quit = 1 Then
			AddHighScore(newgame.L.cashgained, newgame.gamediff)
			Return
		End If
	
		If False Then 'KeyHit(KEY_ESCAPE)  Then
			If fullscreen = 0 Then
				If Confirm("Are you sure you want to quit now?") = 1 Then
					timeToQuit = 1
				End If
			Else
				timetoquit = 1
			End If
		EndIf
		Flip
		Cls
	Wend
End Function

Type game
	Field vehicleGraphics:graphicPile
	'Field interfaceGraphics:graphicPile
	Field score
	Field ambPercent# = .15
	Field ambSiren:TSound
	Field miscGraphics:graphicPile
	Field sounds:soundPile
	Field roadGraphics:graphicPile
	Field L:lawyer, maxVehicles = 15, vehicleSpawnTimer#=-10, vehicleSpawnMaxTime# = .6, vehicleSpawnMinTime  = .1
	Field perAmbulanceCashCount = 5
	Field keys[], vehicles:TList, cashlist:TList
	Field vData:vehicleinfo[]
	Field lanes:TList[]
	Field over = 0
	Field gamesound:audioContext
	Field LawyerDeathTimer# = 0, lawyerDeathTimerMax# = 4
	Field gameDiff$
	
	Function Create:game(diff$ = "Associate")
		ng:game = New game; ng.L = lawyer.create(320, 240, ng)
		
		If diff = "Senior Partner" Then
			ng.maxVehicles = 99
			ng.vehicleSpawnMaxTime# = .4
			ng.vehicleSpawnMinTime  = .1
			ng.ambPercent# = .1
		End If
		
		If diff = "Partner" Then
			ng.maxVehicles = 99
			ng.vehicleSpawnMaxTime# = .6
			ng.vehicleSpawnMinTime  = .1
			ng.ambPercent# = .15
		End If
		
		If diff = "Associate" Then
			ng.maxVehicles = 25
			ng.vehicleSpawnMaxTime# = .9
			ng.vehicleSpawnMinTime  = .1
			ng.ambPercent# = .2
		End If
		
		If diff = "Legal Aid" Then
			ng.maxVehicles = 15
			ng.vehicleSpawnMaxTime# = 1
			ng.vehicleSpawnMinTime  = .3
			ng.ambPercent# = .3
		End If
		
		If diff = "Mailboy" Then
			ng.maxVehicles = 4
			ng.vehicleSpawnMaxTime# = .6
			ng.vehicleSpawnMinTime  = .3
			ng.ambPercent# = .2
		End If
		
		ng.gamediff = diff
	
		ng.keys = [KEY_UP, KEY_RIGHT, KEY_DOWN, KEY_LEFT]
		ng.vehicleGraphics = graphicPile.create(); LoadImagesFromDir("Data/Trucks", ng.vehicleGraphics)
		LoadImagesFromDir("Data/Ambulance", ng.vehicleGraphics)
		ng.roadGraphics = graphicPile.create(); LoadImagesFromDir("Data/Road", ng.roadGraphics)
		ng.miscGraphics = graphicPile.create(); LoadImagesFromDir("Data/Misc Graphics", ng.miscGraphics)
		'ng.interfaceGraphics = graphicPile.create(); LoadImagesFromDir("Interface", ng.interfaceGraphics)
		ng.generateVehicleData() 
		ng.vehicles = CreateList()
		ng.cashlist = CreateList()
		ng.ambSiren = LoadSound("Data/Sounds/siren3.ogg", 1)
		
		ng.sounds = soundpile.create(); LoadSoundsFromDir("Data/Sounds", ng.sounds)
		ng.gamesound = audioContext.create(16)
		
		ng.lanes = New TList[width / 80]
		For i = 0 To ng.lanes.length-1
			ng.lanes[i] = CreateList()
		Next
		Return ng
	End Function
	
	Method generateVehicleData()
		s:TStream = OpenFile("Data/Vehicle Data.txt")
		vData = New vehicleInfo[0]
		While Not Eof(s)
			vData = vData[..vData.length+1]
			vData[vData.length-1] = vehicleInfo.load(s)
		Wend
		If debug Then
			Print "Loaded vehicles:"
			For i = 0 To vData.length-1
				Print vData[i].graphicBaseName
			Next
		End If
	End Method
	
	Method update()
		If lawyerdeathtimer > 0 And lawyerdeathtimer < .2 Then
			FlushKeys()
		End If
		If L.alive = 0 And lawyerDeathTimer < 0 Then
			If (KeyHit(KEY_ENTER) Or KeyHit(KEY_RETURN) Or KeyHit(KEY_ESCAPE) Or MouseHit(1)) Then
				over = 1
				Return
			End If
		End If
	
		L.update()
		For i:vehicle = EachIn vehicles
			i.update()
			If i.dead Then ListRemove(vehicles, i)
		Next
		clearDead()
		spawnVehicles()
		collideVehiclesWithLawyer()
		
		For r:cash = EachIn cashlist
			r.update()
			If r.dead Then ListRemove(cashlist, r)
		Next
		CollideCashWithLawyer()
		gamesound.update()
		
		If L.alive = 0 Then
			lawyerDeathTimer = lawyerDeathTimer - DeltaT
		End If
	End Method
	
	Method clearDead()
		For i:vehicle = EachIn vehicles
			If i.dead Then ListRemove(vehicles, i)
		Next
		For g = 0 To lanes.length - 1
			For i:vehicle = EachIn lanes[g]
			If i.dead Then ListRemove(lanes[g], i)
		Next
		Next
	End Method
	
	Method drawRoad()
		edgeimg:timage = roadGraphics.named("Road Edge")
		DrawImage(edgeimg, edgeimg.width * .5, edgeimg.height * .5)
		SetScale(-1, 1)
		DrawImage(edgeimg, width - edgeimg.width * .5, edgeimg.height * .5)
		SetScale(1, 1)
		
		roadimg:TImage = roadGraphics.named("Road")
		For i = 1 To width / 80 - 2
			DrawImage(roadimg, roadimg.width*.5 + 80*i, roadimg.height*.5)
		Next
		
		SetScale(1, 1)
		DrawImage(edgeimg, width/2 + edgeimg.width * .5, edgeimg.height * .5)
		SetScale(-1, 1)
		DrawImage(edgeimg, width/2 - edgeimg.width * .5, edgeimg.height * .5)
		SetScale(1, 1)
	End Method
	
	Method draw(offx=0, offy=0)
		drawRoad()
		SetBlend(Alphablend)
		For r:cash = EachIn cashlist
			r.draw(offx, offy)
		Next
		L.draw(offx, offy)
		For i:vehicle = EachIn vehicles
			i.draw(offx, offy)
		Next
		'drawImage(interfaceGraphics.named("Rush Hour"), width/2, height/2)
		If L.alive = 0 Then
			SetAlpha((lawyerDeathTimerMax - lawyerDeathTimer)/lawyerDeathTimerMax)
			DrawImage(interfaceGraphics.named("Lose"), width/2, height/2)
			SetAlpha(1)
		End If
		DrawScore()
	End Method
	
	Method DrawScore()
		c = L.cashGained/4 + .5
		SetScale(.2, .2)
		SetColor(200,255,200)
		SetAlpha(1)
		
		For i = 1 To c
			xfac# = Sin(i*15) * 15			
			'DrawImage(miscgraphics.named("cash wad"), width - 10 - xfac       , height*.5 + ((i - (c*.5)) * (height/c))  )
			'DrawImage(miscgraphics.named("cash wad"), 10 + xfac       , height*.5 + ((i - (c*.5)) * (height/c)) )
			SetRotation(90)
			DrawImage(miscgraphics.named("cash wad"), width*.5 + ((i - (c*.5)) * (width/c)),       10  + xfac     )
			DrawImage(miscgraphics.named("cash wad"), width*.5 + ((i - (c*.5)) * (width/c)),      height -10  - xfac     )
			'SetRotation(0)
		Next
		SetColor(255,255,255)
		SetAlpha(1)
		SetRotation(0)
		SetScale(1,1)
	End Method
	
	Method spawnVehicles()
		vehicleSpawnTimer = vehicleSpawnTimer - DeltaT
		If vehicleSpawnTimer <= 0 And CountList(vehicles) < maxVehicles Then
			If Rnd(0,1) < ambPercent Then
				spawnAmbulance()
			Else
				xpos = getFreeLanePos()
				If xpos = -1 Then
					Return
				End If
				vInfo:vehicleInfo = vData[Rand(1,vData.length-1)]
				If xpos < width/2 Then
				 	ypos = -200
				 	speedMod = 1
				Else
					ypos = height + 200
					speedMod = -1
				End If
				newvehicle:vehicle = vehicle.create(Self, xpos + Rand(-4, 4), ypos, vInfo.vwidth, vInfo.vheight, vehicleGraphics, vInfo.graphicBaseName, vInfo.speed  * speedMod, (xpos-40)/80, 0)
				ListAddLast(vehicles, newvehicle)
				ListAddLast(lanes[xpos / 80], newvehicle)
				vehicleSpawnTimer = Rnd(vehicleSpawnMinTime, vehicleSpawnMaxTime)
			End If
		End If
	End Method
	
	Method spawnAmbulance()
			xpos = getFreeLanePos()
			If xpos = -1 Then
				Return
			End If
			vInfo:vehicleInfo = vData[0]
			If xpos < width/2 Then
				ypos = -200
				speedMod = 1
			Else
				ypos = height + 200
				speedMod = -1
			End If
			newvehicle:vehicle = vehicle.create(Self, xpos + Rand(-4, 4), ypos, vInfo.vwidth, vInfo.vheight, vehicleGraphics, vInfo.graphicBaseName, vInfo.speed * speedMod, (xpos-40)/80, 1)
			ListAddLast(vehicles, newvehicle)
			ListAddLast(lanes[xpos / 80], newvehicle)
			vehicleSpawnTimer = Rnd(vehicleSpawnMinTime, vehicleSpawnMaxTime)
	End Method
	
	Method getFreeLanePos:Int()
		staylooping = 30
		lane = Rand(0, lanes.length-1)
		While occupiedLane(lane) And staylooping > 0 
			staylooping = staylooping - 1
			lane = Rand(0, lanes.length-1)
		Wend
		If staylooping <= 0 Then
			Return -1
		End If
		Return lane*80 + 40
	End Method
	
	Method occupiedLane(lane)
		For i:vehicle = EachIn lanes[lane]
			If i.y < 0 +  i.vheight*.5 Or i.y > height -  i.vheight*.5 Then
				Return 1
			End If
		Next
		Return 0
	End Method
	
	Method collideVehiclesWithLawyer()
		laneLeft = (L.x - 40) / 80
		laneRight = (L.x - 40) / 80 + 1
		If laneLeft >= 0 And laneLeft <= lanes.length -1 Then
			For i:vehicle = EachIn lanes[laneLeft]
				collideVehicleWithLawyer(i)
			Next
		End If
		If laneRight >= 0 And laneRight <= lanes.length -1 Then
			For i:vehicle = EachIn lanes[laneRight]
				collideVehicleWithLawyer(i)
			Next
		End If
	End Method
	
	Method XposToLane:Int(xpos)
		lane = (xpos - 40) / 80
		If lane >= lanes.length Or lane < 0 Then
			Return -1
		End If
		Return lane
	End Method
	
	Method createAmbulanceCash(ambx, amby)
		'(g:Timage, px, py, pz=0, pvx=0, pvy=0, pvz=0)
		gamesound.playsnd(sounds.named("cashreg"), 0)
		For i = 1 To perAmbulanceCashCount
			nc:cash = cash.create(miscGraphics.named("cash wad"), ambx, amby, 0, Rnd(-150, 150), Rnd(-150,150), Rnd(.7, 1.3))
			ListAddLast(cashlist, nc)
		Next
	End Method
	
	Method CollideCashWithLawyer()
		maxDist = 40
		For i:cash = EachIn cashlist
			If i.dead <> 1 And L.alive = 1 Then
				If (i.x - L.x)*(i.x - L.x) + (i.y - L.y)*(i.y - L.y) < maxDist * maxDist Then
					i.dead = 1
					L.cashGained = L.cashGained + 1
				End If
			End If
		Next
	End Method
	
	Method LawyerInLane:Int(testlane)
		laneLeft = (L.x - 40) / 80
		laneRight = (L.x - 40) / 80 + 1
		If laneLeft >= 0 And laneLeft <= lanes.length -1 And laneLeft = testlane Then
			Return 1
		End If
		If laneRight >= 0 And laneRight <= lanes.length -1 And laneRight = testlane Then
			Return 1
		End If
		Return 0
	End Method
	
	Method collideVehicleWithLawyer(i:vehicle)
		minKillSpeed = 100
		Print L.alive
		
		If Abs(i.x - L.x) <= L.pwidth*.5 + i.vwidth*.5 And Abs(i.y - l.y) < L.pheight*.5 + i.vheight*.5 Then
			Print "over"
			If L.alive = 1 Then
			
				'Death
				If (i.speed * i.speedmod > minKillSpeed And i.y < L.y) Or (i.speed * i.speedmod < -minKillSpeed And i.y > L.y) Then
					L.alive = 0
					lawyerDeathTimer = lawyerDeathTimerMax
				Else
					If L.x < i.x Then 
						L.x = i.x - i.vwidth*.5 - L.pwidth * .5 - 1
					End If
					If L.x >= i.x Then 
						L.x = i.x + i.vwidth*.5 + L.pwidth * .5 + 1
					End If
				End If
				rem
				'Deflection
				If (i.speed * i.speedmod < minKillSpeed) And (i.speed * i.speedmod > -minKillSpeed) Then
					
				End If
				end rem
			Else
				Print "jiggling"
				L.facing = L.facing + Rand(-15,15)
				L.y = L.y + (1 * Rand((i.speed* i.speedmod)/3, i.speed* i.speedmod))*deltaT
			End If
			
		End If
		rem
		If L.alive = 0 Then
			L.facing = L.facing + Rand(-15,15)
			L.y = L.y + (1 * Rand((i.speed* i.speedmod)/3, i.speed* i.speedmod))*deltaT
		End If
		end rem
		
		rem
		If L.alive = 1 Then
			If Abs(l.x - i.x) < l.pwidth*.5 + i.vwidth*.5 Then
				If Abs(l.y - i.y) < l.pheight*.5 + i.vheight*.5 Then
					If i.speed * i.speedmod > minKillSpeed Then
					End If
				End If
			End If
		End If
		end rem
	End Method
	
	Method vehicleBlockedSpeedModifier:Float(v:vehicle, Lane)
		safedist = 70; minDist = 30

		For i:vehicle = EachIn lanes[lane]
			If i <> v Then
				If v.speed > 0 And i.y > v.y Then
					dist1 = Abs(i.y - v.y) -  i.vheight*.5 - v.vheight*.5
					If dist1 < safeDist And dist1 > 0 And v.speed > 0 Then
						Return Float(i.speed * i.speedmod) / Float(v.speed)
					End If
				End If
				
				If v.speed < 0 And i.y < v.y Then
					dist2 = Abs(i.y - v.y) -  i.vheight*.5 - v.vheight*.5 
					If dist2 < safeDist And dist2 > 0 And v.speed < 0 Then
						Return Float(i.speed * i.speedmod) / Float(v.speed)
					End If
				End If
			End If
		Next
		
		If v.isambulance = 1 And LawyerInLane(lane) And L.alive = 1Then
			If v.speed < 0 And L.y < v.y And v.y - l.y < (safedist + v.vheight  + l.pheight) Then
				speedMod# = (v.y - l.y - minDist - v.vheight  + l.pheight) / (safedist + v.vheight  + l.pheight)
				If speedmod >= 0 Then
					If speedmod < .05 And v.ambulanceUsed = 0 Then
						createAmbulanceCash(v.x, v.y)
						v.startAmbulanceDance()
						v.ambulanceUsed = 1
					End If
					Return speedmod
				Else
					Return 0
			 	End If
			End If
			If v.speed > 0 And l.y > v.y And l.y - v.y < (safedist + v.vheight + l.pheight) Then
				speedMod# = (l.y - v.y - minDist  - v.vheight  + l.pheight) / (safedist + v.vheight  + l.pheight)
				If speedmod >= 0 Then
					If speedmod < .05 And v.ambulanceUsed = 0 Then
						createAmbulanceCash(v.x, v.y)
						v.startAmbulanceDance()
						v.ambulanceUsed = 1
					End If
					Return speedmod
				Else
					Return 0
			 	End If
			End If
		End If
	
		Return 1
	End Method
	
	Method getdistancevol:Float(fx#, fy#)
		dist = (fx - L.x) * (fx - L.x) +  (fy - L.y) * (fy - L.y)
		maxdist:Float = 700
		If dist > maxdist * maxdist Then
			Return 0
		End If
		
		Return (1 - (  dist / (maxdist * maxdist)))  * .1
	End Method
End Type

Type cash
	Global cashRegScale# = .17
	Field vx#, vy#, vz#, x#, y#, z#=0, zgravity# = -3, lifetime# = 20, rot=0#, vrot#
	Field myGraphic:Timage, dead = 0
	
	Function Create:cash(g:Timage, px, py, pz#=0, pvx#=0, pvy#=0, pvz#=0)
		nc:cash = New cash; nc.mygraphic = g; nc.x = px; nc.y = py
		nc.z = pz; nc.vx = pvx; nc.vy = pvy; nc.vz = pvz
		nc.rot = Rand(360); nc.vrot = Rnd(-30,30)
		Return nc
	End Function
	
	Method physnax()
		z = z + vz * DeltaT
		vz = vz + zgravity * DeltaT
		If z > 0 Then
			rot = rot + vrot * DeltaT
			x = x + vx * DeltaT
			y = y + vy * DeltaT
		Else
			z=0
		End If
	End Method
	
	Method update()
		If dead <> 1 Then
			physnax()
		End If
	End Method
	
	Method Draw(offx=0, offy=0)
		SetRotation(rot)
		SetScale(cashRegScale+z, cashRegScale+z)
		SetBlend(AlphaBlend)
		DrawImage(myGraphic, x + offx, y + offy)
		SetScale(1,1)
		SetRotation(0)
	End Method
End Type

Type vehicleInfo
	Field name$, vwidth, vheight, speed#, graphicBaseName$, frequency#
	Function Load:vehicleinfo(s:TStream)
		vi:vehicleInfo = New vehicleinfo
		vi.name = ReadLine(s)
		nothing$ = ReadLine(s)
		vi.vwidth = Int(ReadLine(s))
		vi.vheight = Int(ReadLine(s))
		nothing = ReadLine(s)
		vi.speed = Float(ReadLine(s))
		nothing = ReadLine(s)
		vi.graphicBaseName = ReadLine(s)
		nothing = ReadLine(s)
		vi.frequency = Float(ReadLine(s))
		nothing = ReadLine(s)
		Return vi
	End Function
End Type

Type vehicle
	Field x#, y#, vwidth#, vheight#, speed#, isAmbulance, graphicBaseName$, gPile:graphicpile, Dead = 0
	Field safeDistance, minSafeDistance = 30, lightRot#=0, speedmod# = 1, ownerGame:game, lane, ambulanceUsed =0
	Field ambyoffset1, ambyoffset2, ambOpenAnim:animation, ambYellAnim:animation
	Field ambOpening=0, ambYellTimer#=0, ambDancing = 0, ambYelling
	Field myChan
	
	Function create:vehicle(pownerGame:game, px, py, pvwidth, pvheight, pgPile:graphicpile, pgraphicBaseName$, pspeed#, plane, pIsAmbulance = 0)
		nv:vehicle = New vehicle; nv.x = px; nv.y = py; nv.vwidth = pvwidth; nv.vheight = pvheight; nv.ownergame = pownerGame
		nv.speed = pspeed; nv.graphicBaseName = pgraphicBaseName; nv.gpile = pgpile; nv.IsAmbulance = pIsAmbulance; nv.lane = plane
		If pIsAmbulance = 1 Then
			If pspeed > 0 Then
				ambyoffset1 = -5
				ambyoffset2 = -5
				nv.ambYellAnim = animation.create("Ambulance Down Yell", pgPile, 1, 3/30.0)
				nv.ambOpenAnim = animation.create("Ambulance Down Open", pgPile, 0, 4/30.0)
			Else
				ambyoffset1 = 5
				ambyoffset2 = 5
				nv.ambYellAnim = animation.create("Ambulance Up Yell", pgPile, 1, 3/30.0)
				nv.ambOpenAnim = animation.create("Ambulance Up Open", pgPile, 0, 4/30.0)
			End If
			nv.ownergame = pownergame
			nv.ownergame.gameSound.inactiveVolumesToZero()
			nv.myChan = nv.ownergame.gameSound.playsnd(nv.ownergame.sounds.named("siren"), 1)
			sirenVol:Float = nv.ownergame.getDistanceVol(x, y)
			SetChannelVolume(nv.ownergame.gamesound.channels[mychan], sirenVol)
			
			'nv.ambYellAnim.play()
			'nv.ambOpenAnim.play()
		End If
		Return nv
	End Function
	
	Method draw(offx=0, offy=0)
		If speed > 0 Then
			str$ = " Down"
		Else
			str$ = " Up"
		End If
		
		If isambulance = 1 Then
		
			If ambOpening = 1 Then 
				ambOpenAnim.draw(x + offx, y + offy)
			Else
				If ambYellTimer > 0 Or ambYelling = 1 Then 
					ambYellAnim.draw(x + offx, y + offy)
				Else
					DrawImage(gpile.named(graphicBaseName + str), x + offx, y + offy)
				End If
			End If
			
			lightRot = lightRot + 300 * deltaT
			SetBlend(lightblend)
			SetScale(3,3)
			SetAlpha((lightRot Mod 50)/200.0)
			SetRotation(lightRot)
			
			DrawImage(gPile.named("Flashing Lights"), x + offx, y + offy)
			
			SetBlend(AlphaBlend)
			SetAlpha(1)
			SetScale(1,1)
			SetRotation(0)
		Else
			DrawImage(gpile.named(graphicBaseName + str), x + offx, y + offy)
		End If
		vwidth = ImageWidth(gpile.named(graphicBaseName + str))
		vheight = ImageHeight(gpile.named(graphicBaseName + str))
	End Method
	
	Method startAmbulanceDance()
		ambOpening = 1
		ambDancing = 1
		ambOpenAnim.play()
	End Method
	
	Method update()
		If dead = 0 Then
		
			If ambDancing = 1 Then
				If ambOpening = 1 And isAmbulance = 1 Then ambOpenAnim.update()
				If ambYelling = 1 And isAmbulance = 1 Then ambYellAnim.update()
			End If
			If ambOpening = 1 And ambOpenAnim.currentframe = ambOpenAnim.framenums.length - 1 Then
				Print "Switching to yelling"
				ambOpening = 0
				ambYelling = 1
				ambYellAnim.play()
			End If
			speedmod = ownerGame.vehicleBlockedSpeedModifier(Self, lane)
			y = y + speed * DeltaT * speedmod
			If isAmbulance = 1 Then
				If speed > 0 Then
					If y > vheight + height + 700 Then Dead = 1
				Else
					If y < 0 - vheight - 700 Then Dead = 1
				End If
			Else
				If speed > 0 Then
					If y > vheight + height Then Dead = 1
				Else
					If y < 0 - vheight Then Dead = 1
				End If
			End If
			
			If isAmbulance = 1
				sirenVol:Float = ownergame.getDistanceVol(x, y)
				SetChannelVolume(ownergame.gamesound.channels[mychan], sirenVol)
			End If
		End If
		
		If dead = 1 Then
			If isAmbulance = 1 Then
				ownergame.gameSound.stopsnd(mychan)
				SetChannelVolume(ownergame.gamesound.channels[mychan], 0)
			End If
		End If
	End Method
End Type

Type lawyer
	Field lawyerGraphics:graphicpile, alive=1, cashGained=0
	Field runUp:animation, runDown:animation, runLeft:animation, runRight:animation
	Field runUpRight:animation, runUpLeft:animation, runDownRight:animation, runDownLeft:animation
	Field x#, y#, facing, speed#=400, ownerGame:game, moved
	Field pwidth = 18, pheight = 58
	
	Function create:lawyer(px=0, py=0, pownerGame:game)
		nl:lawyer = New lawyer
		nl.x = px; nl.y = py; nl.ownerGame = pownerGame
		nl.lawyerGraphics = graphicpile.create(); LoadImagesFromDir("Data/Lawyer Anims", nl.lawyerGraphics)
		nl.BuildAnimations()
		Return nl
	End Function
	
	Method BuildAnimations()
		runUp = animation.create("Run Up", lawyerGraphics, 1); runUp.play()
		runDown = animation.create("Run Down", lawyerGraphics, 1); runDown.play()
		runLeft = animation.create("Run Left", lawyerGraphics, 1); runLeft.play()
		runRight = animation.create("Run Right", lawyerGraphics, 1); runRight.play()
		runUpRight = animation.create("Run Up Right", lawyerGraphics, 1); runUpRight.play()
		runUpLeft = animation.create("Run Up Left", lawyerGraphics, 1); runUpLeft.play()
		runDownRight = animation.create("Run Down Right", lawyerGraphics, 1); runDownRight.play()
		runDownLeft = animation.create("Run Down Left", lawyerGraphics, 1); runDownLeft.play()
	End Method
	
	Method update()
		If alive = 1 Then
			moved = 0
			moveLawyer()
			runUp.update(); runDown.update(); runLeft.update(); runRight.update()
			runUpRight.update(); runUpLeft.update(); runDownRight.update(); runDownLeft.update()
		End If
	End Method
	
	Method draw(offx=0, offy=0)
		If alive = 1 Then
			drawDirectionalAnim(offx, offy)
		Else
			SetRotation(facing+90)
			DrawImage(	lawyergraphics.named("Flattened Up"), x + offx, y + offy)
			SetRotation(0)
		End If
	End Method
	
	Method drawDirectionalAnim(offx=0, offy=0)
		If facing >= 360 Then facing = facing - 360
		If moved Then
			Select facing
			Case 0
				runRight.draw(x + offx, y + offy)
			Case 315
				runUpRight.draw(x + offx, y + offy)
			Case 270
				runUp.draw(x + offx, y + offy)
			Case 225
				runUpLeft.draw(x + offx, y + offy)
			Case 180
				runLeft.draw(x + offx, y + offy)
			Case 135
				runDownLeft.draw(x + offx, y + offy)
			Case 90
				runDown.draw(x + offx, y + offy)
			Case 45
				runDownRight.draw(x + offx, y + offy)
			End Select
		Else
			Select facing
			Case 0
				DrawImage(LawyerGraphics.named("Face Right"), x + offx, y + offy)
			Case 315
				DrawImage(LawyerGraphics.named("Face Up Right"), x + offx, y + offy)
			Case 270
				DrawImage(LawyerGraphics.named("Face Up"), x + offx, y + offy)
			Case 225
				DrawImage(LawyerGraphics.named("Face Up Left"), x + offx, y + offy)
			Case 180
				DrawImage(LawyerGraphics.named("Face Left"), x + offx, y + offy)
			Case 135
				DrawImage(LawyerGraphics.named("Face Down Left"), x + offx, y + offy)
			Case 90
				DrawImage(LawyerGraphics.named("Face Down"), x + offx, y + offy)
			Case 45
				DrawImage(LawyerGraphics.named("Face Down Right"), x + offx, y + offy)
			End Select
		End If
	End Method
	
	Method moveLawyer()
		If KeyDown(ownerGame.keys[0]) Then
			facing = 270
			moved = 1
		End If
		If KeyDown(ownerGame.keys[1]) Then
			facing = 0
			moved = 1
		End If
		If KeyDown(ownerGame.keys[2]) Then
			facing = 90
			moved = 1
		End If
		If KeyDown(ownerGame.keys[3]) Then
			facing = 180
			moved = 1
		End If
		If KeyDown(ownerGame.keys[0]) And KeyDown(ownerGame.keys[1])Then
			facing = 315
			moved = 1
		End If
		If KeyDown(ownerGame.keys[0]) And KeyDown(ownerGame.keys[3]) Then
			facing = 225
			moved = 1
		End If
		If KeyDown(ownerGame.keys[2]) And KeyDown(ownerGame.keys[1])Then
			facing = 45
			moved = 1
		End If
		If KeyDown(ownerGame.keys[2]) And KeyDown(ownerGame.keys[3]) Then
			facing = 135
			moved = 1
		End If
		x = x + speed*moved*Cos(facing)*DeltaT; y = y + speed*moved*Sin(facing)*DeltaT
		If x - pwidth * .5 < 0 Then
			x = pwidth * .5
		End If
		If x + pwidth * .5 > width Then
			x = width - pwidth * .5
		End If
		If y - pheight * .5 < 0 Then
			y = pheight * .5
		End If
		If y + pheight * .5 > height Then
			y = height - pheight * .5
		End If
	End Method
End Type
























